From ae34ea4dd2bb8c9e78878516914111c8fc677e92 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: May 04 2017 22:07:32 +0000
Subject: [PATCH 834/1001] Don't confuse the app and the current_app proxy in signals


---

diff --git a/hubs/tests/__init__.py b/hubs/tests/__init__.py
index 2630d8c..6680c2c 100644
--- a/hubs/tests/__init__.py
+++ b/hubs/tests/__init__.py
@@ -104,9 +104,8 @@ class APPTest(unittest.TestCase):
 
     def check_url(self, url, user=None, code=200):
         with auth_set(hubs.app.app, user):
-            with hubs.app.app.app_context():
-                with captured_templates(flask.current_app) as templates:
-                    response = self.app.get(url)
+            with captured_templates(hubs.app.app) as templates:
+                response = self.app.get(url)
         self.assertEqual(response.status_code, code)
         if templates:
             self.assertEqual(len(templates), 1)
diff --git a/hubs/widgets/halp/views.py b/hubs/widgets/halp/views.py
index 11ae36e..2b5b2b4 100644
--- a/hubs/widgets/halp/views.py
+++ b/hubs/widgets/halp/views.py
@@ -195,10 +195,13 @@ def add_view(hub):
         )
     initial["hubs"] = [hub.name]
     context = dict(mode="add", url=post_url, initial=initial)
+    # Mimic flask.templating._render(). Too bad it's not a public API.
     if before_render_template is not None:
         before_render_template.send(
-            flask.current_app, template=template, context=context)
+            flask._app_ctx_stack.top.app,
+            template=template, context=context)
     output = template.render(**context)
     template_rendered.send(
-        flask.current_app, template=template, context=context)
+        flask._app_ctx_stack.top.app,
+        template=template, context=context)
     return output
diff --git a/hubs/widgets/view.py b/hubs/widgets/view.py
index 4fdb936..65d91c5 100644
--- a/hubs/widgets/view.py
+++ b/hubs/widgets/view.py
@@ -125,10 +125,13 @@ class WidgetView(View):
         else:
             context.update(self.get_extra_context(instance, *args, **kwargs))
             template = self.get_template()
+            # Mimic flask.templating._render(). Too bad it's not a public API.
             if before_render_template is not None:
                 before_render_template.send(
-                    flask.current_app, template=template, context=context)
+                    flask._app_ctx_stack.top.app,
+                    template=template, context=context)
             output = template.render(**context)
             template_rendered.send(
-                flask.current_app, template=template, context=context)
+                flask._app_ctx_stack.top.app,
+                template=template, context=context)
             return output

